<?php

defined('_JEXEC') or die('Restricted access');

class BackendControllerCategories extends BackendController
{
	function __construct()
	{
		parent::__construct();

		$this->registerTask('add', 'edit');
	}

	function edit()
  {
    JRequest::setVar('view',   'category');
    JRequest::setVar('layout', 'form');
    JRequest::setVar('hidemainmenu', 1);

    parent::display();
  }

	function change()
  {
    $model = $this->getModel('category');

    if ($model->change())
    {
      $msg = JText::_('State changed!');
    }
    else
    {
      $msg = JText::_('Error Changing State');
    }

    $this->setRedirect('index.php?option=com_hotornot&task=categories', $msg);
  }

  function publish()
  {
    $model = $this->getModel('category');

    if ($model->publish())
    {
      $msg = JText::_('Category(s) published!');
    }
    else
    {
      $msg = JText::_('Error Publishing Category(s)');
    }

    $this->setRedirect('index.php?option=com_hotornot&task=categories', $msg);
  }

  function unpublish()
  {
    $model = $this->getModel('category');

    if ($model->unpublish())
    {
      $msg = JText::_('Category(s) unpublished!');
    }
    else
    {
      $msg = JText::_('Error Unpublishing Category(s)');
    }

    $this->setRedirect('index.php?option=com_hotornot&task=categories', $msg);
  }

  function save()
  {
    $model = $this->getModel('category');

    if ($model->store())
    {
      $msg = JText::_('Category Saved!');
    }
    else
    {
      $msg = JText::_('Error Saving Category');
    }

    $this->setRedirect('index.php?option=com_hotornot&task=categories', $msg);
  }

  function remove()
  {
    $model = $this->getModel('category');

    if (!$model->delete())
    {
      $msg = JText::_('Error: One or More Categories Could not be Deleted');
    }
    else
    {
      $msg = JText::_('Category(s) Deleted');
    }

    $this->setRedirect('index.php?option=com_hotornot&task=categories', $msg);
  }

  function cancel()
  {
    $msg = JText::_('Operation Cancelled');

    $this->setRedirect('index.php?option=com_hotornot&task=categories', $msg);
  }

  function orderup()
  {
    $model = $this->getModel('category');

    $model->orderContent(-1);

    $this->setRedirect('index.php?option=com_hotornot&task=categories');
  }

  function orderdown()
  {
    $model = $this->getModel('category');

    $model->orderContent(1);

    $this->setRedirect('index.php?option=com_hotornot&task=categories');
  }

  function saveorder()
  {
    $model = $this->getModel('category');

    $model->saveorder();

    $this->setRedirect('index.php?option=com_hotornot&task=categories');
  }
}