DROP TABLE IF EXISTS `#__hotornot_report`;
DROP TABLE IF EXISTS `#__hotornot_comment`;
DROP TABLE IF EXISTS `#__hotornot_tag`;
DROP TABLE IF EXISTS `#__hotornot_vote`;
DROP TABLE IF EXISTS `#__hotornot_image`;
DROP TABLE IF EXISTS `#__hotornot_image_lovefactory`;
DROP TABLE IF EXISTS `#__hotornot_categories`;

CREATE TABLE IF NOT EXISTS `#__hotornot_comment` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `image_id` bigint(20) DEFAULT NULL,
  `source` varchar(20) NOT NULL,
  `user_id` bigint(20) DEFAULT NULL,
  `receiver_id` bigint(20) DEFAULT NULL,
  `comment` longtext,
  `date_added` datetime DEFAULT NULL,
  `reports` bigint(20) NOT NULL DEFAULT '0',
  `approved` tinyint(1) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=0 ;

CREATE TABLE IF NOT EXISTS `#__hotornot_image` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `user_id` bigint(20) NOT NULL,
  `folder` int(10) unsigned NOT NULL,
  `extension` varchar(10) NOT NULL,
  `hits` bigint(20) DEFAULT '0.00',
  `rank` decimal(4,2) DEFAULT '0.00',
  `date_added` datetime DEFAULT NULL,
  `category_id` int(10) unsigned NOT NULL,
  `description` mediumtext,
  `approved` tinyint(1) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `category_id_idx` (`category_id`),
  KEY `rank_idx` (`rank`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=0;

CREATE TABLE IF NOT EXISTS `#__hotornot_image_lovefactory` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `image_id` int(11) NOT NULL,
  `category_id` int(10) unsigned NOT NULL,
  `hits` int(11) NOT NULL,
  `rank` decimal(4,2) NOT NULL,
  `description` varchar(255) DEFAULT NULL,
  `approved` tinyint(1) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=0 ;

CREATE TABLE IF NOT EXISTS `#__hotornot_report` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `image_id` bigint(20) DEFAULT NULL,
  `source` varchar(20) NOT NULL,
  `name` varchar(255) NOT NULL,
  `email` varchar(255) NOT NULL,
  `message` longtext,
  `date_added` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=0 ;

CREATE TABLE IF NOT EXISTS `#__hotornot_tag` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `image_id` bigint(20) DEFAULT NULL,
  `name` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=0 ;

CREATE TABLE IF NOT EXISTS `#__hotornot_vote` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `user_id` int(11) NOT NULL,
  `ip` varchar(15) NOT NULL,
  `image_id` bigint(11) NOT NULL,
  `source` varchar(20) NOT NULL,
  `voted_at` datetime NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=0 ;

CREATE TABLE IF NOT EXISTS `#__hotornot_categories` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(255) NOT NULL,
  `published` tinyint(1) NOT NULL,
  `ordering` int(11) NOT NULL,
  `icon` varchar(255) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=3 ;

INSERT INTO `#__hotornot_categories` (`id`, `title`, `published`, `ordering`, `icon`) VALUES
(1, 'Male', 1, 1, '1_male.png'),
(2, 'Female', 1, 2, '2_female.png');