<?php

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');

class BackendModelCategory extends JModel
{
  function __construct()
  {
    parent::__construct();

    $cids = JRequest::getVar('cid', 0, '', 'array');
    $this->setId((int)$cids[0]);
  }

  function setId($id)
  {
    $this->_id   = $id;
    $this->_data = null;
  }

  function &getData()
  {
    if (empty($this->_data))
    {
      $query = ' SELECT * FROM #__hotornot_categories'
             . ' WHERE id = '.$this->_id;
      $this->_db->setQuery($query);

      $this->_data = $this->_db->loadObject();
    }

    if (!$this->_data)
    {
      $this->_data = $this->getTable();
    }

    return $this->_data;
  }

  function change()
  {
    $field = JRequest::getVar('field', '', 'GET', 'string');
    $value = JRequest::getVar('value',  0, 'GET', 'integer');
    $id    = JRequest::getVar('id',     0, 'GET', 'integer');

    if (!in_array($field, array('published')))
    {
      return false;
    }

    $query = ' UPDATE #__hotornot_categories'
           . ' SET ' . $field . ' = ' . $value
           . ' WHERE id = ' . $id;
    $this->_db->setQuery($query);

    return $this->_db->query();
  }

  function publish()
  {
    $cids = JRequest::getVar('cid', array(0), 'post', 'array');
    JRequest::setVar('field', 'published', 'GET', true);
    JRequest::setVar('value', 1, 'GET', true);

    foreach ($cids as $cid)
    {
      JRequest::setVar('id', $cid, 'GET', true);

      if (!$this->change())
      {
        $this->setError($field->getErrorMsg());
        return false;
      }
    }

    return true;
  }

  function unpublish()
  {
    $cids = JRequest::getVar('cid', array(0), 'post', 'array');
    JRequest::setVar('field', 'published', 'GET', true);
    JRequest::setVar('value', 0, 'GET', true);

    foreach ($cids as $cid)
    {
      JRequest::setVar('id', $cid, 'GET', true);

      if (!$this->change())
      {
        $this->setError($field->getErrorMsg());
        return false;
      }
    }

    return true;
  }

  function orderContent($direction)
  {
		$cid =& JRequest::getVar('cid', array(), 'post', 'array');

		if (isset($cid[0]))
		{
			$row =& JTable::getInstance('category', 'Table');
			$row->load(intval($cid[0]));
			$row->move($direction);
		}
  }

  function saveorder()
  {
    global $mainframe;

    $cid	 =& JRequest::getVar('cid',   array(0), 'post', 'array');
    $order =& JRequest::getVar('order', array(0), 'post', 'array');
    $total = count($cid);

    JArrayHelper::toInteger($cid,   array(0));
    JArrayHelper::toInteger($order, array(0));

    $row =& JTable::getInstance('category', 'Table');

    for ($i = 0; $i < $total; $i ++)
    {
      $row->load(intval($cid[$i]));

      if ($row->ordering != $order[$i])
      {
        $row->ordering = $order[$i];

        if (!$row->store())
        {
          JError::raiseError(500, $db->getErrorMsg());
          return false;
        }
      }
    }

    return true;
  }

  function store()
  {
    $category =& $this->getTable();
    $data     =  JRequest::get('post');

    if (!$category->bind($data))
    {
      $this->setError($this->_db->getErrorMsg());
      return false;
    }

    if (!$category->check())
    {
      $this->setError($this->_db->getErrorMsg());
      return false;
    }

    // Check if it's a new category
    if ($category->id < 1)
    {
      // Get order
      $category->ordering = $this->getOrdering();
    }
    else
    {
      // Delete old photo
      $delete =& JRequest::getVar('delete', '', 'POST', 'string');

      if ($delete == 'on')
      {
        $temp_category =& $this->getTable();
        $temp_category->load($category->id);

        if (!empty($temp_category->icon))
        {
          $filename = JPATH_COMPONENT_SITE.DS.'upload'.DS.'icons'.DS.$temp_category->icon;

          if (file_exists($filename))
          {
            @unlink($filename);
          }

          $temp_category->icon = '';
          $temp_category->store();
        }
      }

      // Upload new photo
      $icon =& JRequest::getVar('icon', array(), 'FILES', 'array');
      if ($icon['error'] === 0)
      {
        $filename = JPATH_COMPONENT_SITE.DS.'upload'.DS.'icons'.DS.$temp_category->icon.DS.$category->id.'_'.$icon['name'];
        move_uploaded_file($icon['tmp_name'], $filename);

        $category->icon = $category->id.'_'.$icon['name'];
      }
    }

    if (!$category->store())
    {
      $this->setError($this->_db->getErrorMsg());
      return false;
    }

    return true;
  }

  function delete()
  {
    $cids     = JRequest::getVar('cid', array(0), 'post', 'array');
    $category =& $this->getTable();

    foreach($cids as $cid)
    {
      $category->load($cid);
      $filename = null;

      if (!empty($category->icon))
      {
        $filename = JPATH_COMPONENT_SITE.DS.'upload'.DS.'icons'.DS.$category->icon;
      }

      if (!$category->delete($cid))
      {
        $this->setError($field->getErrorMsg());
        return false;
      }

      if (!is_null($filename))
      {
        @unlink($filename);
      }
    }
    return true;
  }

  // Helpers
  function getOrdering()
  {
    $query = ' SELECT MAX(c.ordering)'
           . ' FROM #__hotornot_categories c';
    $this->_db->setQuery($query);

    return (intval($this->_db->loadResult()) + 1);
  }
}