<?php

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');

class BackendModelDelete extends JModel
{
  var $id;
  var $type;
  var $types;

  function __construct()
  {
    $this->id    = JRequest::getVar('id', 0, 'GET', 'integer');
    $this->type  = JRequest::getVar('type', 0, 'GET', 'string');
    $this->types = array(1 => 'image', 2 => 'comment');

    if (!in_array($this->type, array(1, 2)))
    {
      return false;
    }

    parent::__construct();
  }

  function _buildQuery()
  {
    $query = ' DELETE FROM #__hotornot_' . $this->types[$this->type]
           . ' WHERE id = ' . $this->id;

    return $query;
  }

  function getDelete()
  {
    if ($this->type == 2)
    {
      return $this->deleteComment();
    }

    return $this->deleteImage();
  }

  function deleteImage()
  {
    $id     = JRequest::getVar('id', 0, 'REQUEST', 'integer');
    $source = JRequest::getVar('source', '', 'REQUEST', 'string');

    switch ($source)
    {
      case 'hotornot':
        $query = ' SELECT *'
               . ' FROM #__hotornot_image'
               . ' WHERE id = ' . $id;
        $this->_db->setQuery($query);
        $image = $this->_db->loadObject();

        if ($image)
        {
          require_once(JPATH_COMPONENT_SITE.DS.'helper.php');
          require_once(JPATH_COMPONENT_ADMINISTRATOR.DS.'settings.php');
          $settings = new HNConfig();

          $path  = Helper::decodePath($settings->upload_folder).DS.$image->folder.DS.$image->id.'.'.$image->extension;
          $thumb = Helper::decodePath($settings->upload_folder).DS.$image->folder.DS.$image->id.'_thumb.'.$image->extension;
          @unlink($path);
          @unlink($thumb);

          $query = ' DELETE'
                 . ' FROM #__hotornot_comment'
                 . ' WHERE image_id = ' . $image->id
                 . ' AND source = "hotornot"';
          $this->_db->setQuery($query);
          $this->_db->query();

          $query = ' DELETE'
                 . ' FROM #__hotornot_report'
                 . ' WHERE image_id = ' . $image->id
                 . ' AND source = "hotornot"';
          $this->_db->setQuery($query);
          $this->_db->query();

          $query = ' DELETE'
                 . ' FROM #__hotornot_tag'
                 . ' WHERE image_id = ' . $image->id;
          $this->_db->setQuery($query);
          $this->_db->query();

          $query = ' DELETE'
                 . ' FROM #__hotornot_vote'
                 . ' WHERE image_id = ' . $image->id
                 . ' AND source = "hotornot"';
          $this->_db->setQuery($query);
          $this->_db->query();

          $query = ' DELETE'
                 . ' FROM #__hotornot_image'
                 . ' WHERE id = ' . $image->id;
          $this->_db->setQuery($query);
          $this->_db->query();

          return true;
        }
        break;

      case 'lovefactory':
        $query = ' SELECT p.*, i.*'
               . ' FROM #__lovefactory_photos p'
               . ' LEFT JOIN #__hotornot_image_lovefactory i ON p.id = i.image_id'
               . ' WHERE p.id = ' . $id;
        $this->_db->setQuery($query);
        $image = $this->_db->loadObject();

        if ($image)
        {
          $path  = JPATH_SITE.DS.'components'.DS.'com_lovefactory'.DS.'storage'.DS.'photos'.DS.$image->user_id.DS.$image->filename;
          $thumb = JPATH_SITE.DS.'components'.DS.'com_lovefactory'.DS.'storage'.DS.'photos'.DS.$image->user_id.DS.'thumb_'.$image->filename;

          @unlink($path);
          @unlink($thumb);

           $query = ' DELETE'
                  . ' FROM #__hotornot_comment'
                  . ' WHERE image_id = ' . $id
                  . ' AND source = "lovefactory"';
          $this->_db->setQuery($query);
          $this->_db->query();

          $query = ' DELETE'
                 . ' FROM #__hotornot_image_lovefactory'
                 . ' WHERE image_id = ' . $id;
          $this->_db->setQuery($query);
          $this->_db->query();

          $query = ' DELETE'
                 . ' FROM #__hotornot_report'
                 . ' WHERE image_id = ' . $id
                 . ' AND source = "lovefactory"';
          $this->_db->setQuery($query);
          $this->_db->query();

          $query = ' DELETE'
                 . ' FROM #__hotornot_vote'
                 . ' WHERE image_id = ' . $id
                 . ' AND source = "lovefactory"';
          $this->_db->setQuery($query);
          $this->_db->query();

          $query = ' DELETE'
                 . ' FROM #__lovefactory_photos'
                 . ' WHERE id = ' . $id;
          $this->_db->setQuery($query);
          $this->_db->query();

          return true;
        }
        break;
    }

    return false;
  }

  function deleteComment()
  {
    $database =& JFactory::getDBO();

    $query = ' DELETE'
           . ' FROM #__hotornot_comment'
           . ' WHERE id = ' . $this->id;
    $database->setQuery($query);
    return $database->query();
  }
}