<?php

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');

class BackendModelImage extends JModel
{
  function getData()
  {
    $id     = JRequest::getVar('id', 0, 'GET', 'integer');
    $source = JRequest::getVar('source', '', 'GET', 'string');

    $image = null;

    switch ($source)
    {
      case 'hotornot':
        $query = ' SELECT *, "hotornot" AS source'
               . ' FROM #__hotornot_image'
               . ' WHERE id = ' . $id;
        $this->_db->setQuery($query);
        $image = $this->_db->loadObject();

        if ($image)
        {
          $query = ' SELECT *'
                 . ' FROM #__hotornot_tag'
                 . ' WHERE image_id = ' . $id;
          $this->_db->setQuery($query);
          $tags = $this->_db->loadObjectList();

          $array = array();
          foreach ($tags as $tag)
          {
            $array[] = $tag->name;
          }

          $image->tags = implode(', ', $array);
        }
        break;

      case 'lovefactory':
        $query = ' SELECT p.id, p.user_id, p.filename AS extension, "lovefactory" AS source'
               . ' FROM #__lovefactory_photos p'
               . ' LEFT JOIN #__hotornot_image_lovefactory i ON p.id = i.image_id'
               . ' LEFT JOIN #__users u ON u.id = p.user_id'
               . ' WHERE p.id = ' . $id;
        $this->_db->setQuery($query);
        $image = $this->_db->loadObject();
        break;
    }

    return $image;
  }

  function store()
  {
    $id     = JRequest::getVar('id', 0, 'REQUEST', 'integer');
    $tags   = JRequest::getVar('tags', '', 'REQUEST', 'string');
    $source = JRequest::getVar('source', '', 'REQUEST', 'string');

    if ($source == 'hotornot')
    {
      $query = ' DELETE'
             . ' FROM #__hotornot_tag'
             . ' WHERE image_id = ' . $id;
      $this->_db->setQuery($query);
      $this->_db->query();

      $tags = explode(',', $tags);

      $query = ' INSERT'
             . ' INTO #__hotornot_tag (`id`, `image_id`, `name`)'
             . ' VALUES';
      $values = array();
      foreach ($tags as $tag)
      {
        if (trim($tag) != '')
        {
          $values[] = '("", ' . $id . ', "' . trim($tag) . '")';
        }
      }

      $values = implode(', ', $values);
      $query .= $values;

      $this->_db->setQuery($query);

      if ('' != $values)
      {
        $this->_db->query();
      }
    }

    $image =& $this->getTable();
    $image->load($id);

    $data = JRequest::get('post');

    if (!$image->bind($data))
    {
      $this->setError($this->_db->getErrorMsg());
      return false;
    }

    if (!$image->check())
    {
      $this->setError($this->_db->getErrorMsg());
      return false;
    }

    if (!$image->store())
    {
      $this->setError($this->_db->getErrorMsg());
      return false;
    }

    return true;
  }

  function deleteList()
  {
    $cids = JRequest::getVar('cid', array(0), 'post', 'array');

    require_once(JPATH_COMPONENT_SITE.DS.'helper.php');
    if (Helper::getPhotoSource() == 0)
    {
      JRequest::setVar('source', 'hotornot', 'GET', true);
    }
    else
    {
      JRequest::setVar('source', 'lovefactory', 'GET', true);
    }

    foreach ($cids as $cid)
    {
      JRequest::setVar('id', $cid, 'GET', true);

      $this->delete();
    }

    return true;
  }

  function delete()
  {
    $id     = JRequest::getVar('id', 0, 'REQUEST', 'integer');
    $source = JRequest::getVar('source', '', 'REQUEST', 'string');

    switch ($source)
    {
      case 'hotornot':
        $query = ' SELECT *'
               . ' FROM #__hotornot_image'
               . ' WHERE id = ' . $id;
        $this->_db->setQuery($query);
        $image = $this->_db->loadObject();

        if ($image)
        {
          require_once(JPATH_COMPONENT_SITE.DS.'helper.php');
          require_once(JPATH_COMPONENT_ADMINISTRATOR.DS.'settings.php');
          $settings = new HNConfig();

          $path  = Helper::decodePath($settings->upload_folder).DS.$image->folder.DS.$image->id.'.'.$image->extension;
          $thumb = Helper::decodePath($settings->upload_folder).DS.$image->folder.DS.$image->id.'_thumb.'.$image->extension;
          @unlink($path);
          @unlink($thumb);

          $query = ' DELETE'
                 . ' FROM #__hotornot_comment'
                 . ' WHERE image_id = ' . $image->id
                 . ' AND source = "hotornot"';
          $this->_db->setQuery($query);
          $this->_db->query();

          $query = ' DELETE'
                 . ' FROM #__hotornot_report'
                 . ' WHERE image_id = ' . $image->id
                 . ' AND source = "hotornot"';
          $this->_db->setQuery($query);
          $this->_db->query();

          $query = ' DELETE'
                 . ' FROM #__hotornot_tag'
                 . ' WHERE image_id = ' . $image->id;
          $this->_db->setQuery($query);
          $this->_db->query();

          $query = ' DELETE'
                 . ' FROM #__hotornot_vote'
                 . ' WHERE image_id = ' . $image->id
                 . ' AND source = "hotornot"';
          $this->_db->setQuery($query);
          $this->_db->query();

          $query = ' DELETE'
                 . ' FROM #__hotornot_image'
                 . ' WHERE id = ' . $image->id;
          $this->_db->setQuery($query);
          $this->_db->query();

          return true;
        }
        break;

      case 'lovefactory':
        $query = ' SELECT p.*, i.*'
               . ' FROM #__lovefactory_photos p'
               . ' LEFT JOIN #__hotornot_image_lovefactory i ON p.id = i.image_id'
               . ' WHERE p.id = ' . $id;
        $this->_db->setQuery($query);
        $image = $this->_db->loadObject();

        if ($image)
        {
          $path  = JPATH_SITE.DS.'components'.DS.'com_lovefactory'.DS.'storage'.DS.'photos'.DS.$image->user_id.DS.$image->extension;
          $thumb = JPATH_SITE.DS.'components'.DS.'com_lovefactory'.DS.'storage'.DS.'photos'.DS.$image->user_id.DS.'thumb_'.$image->extension;

          @unlink($path);
          @unlink($thumb);

           $query = ' DELETE'
                  . ' FROM #__hotornot_comment'
                  . ' WHERE image_id = ' . $id
                  . ' AND source = "lovefactory"';
          $this->_db->setQuery($query);
          $this->_db->query();

          $query = ' DELETE'
                 . ' FROM #__hotornot_image_lovefactory'
                 . ' WHERE image_id = ' . $id;
          $this->_db->setQuery($query);
          $this->_db->query();

          $query = ' DELETE'
                 . ' FROM #__hotornot_report'
                 . ' WHERE image_id = ' . $id
                 . ' AND source = "lovefactory"';
          $this->_db->setQuery($query);
          $this->_db->query();

          $query = ' DELETE'
                 . ' FROM #__hotornot_vote'
                 . ' WHERE image_id = ' . $id
                 . ' AND source = "lovefactory"';
          $this->_db->setQuery($query);
          $this->_db->query();

          $query = ' DELETE'
                 . ' FROM #__lovefactory_photos'
                 . ' WHERE id = ' . $id;
          $this->_db->setQuery($query);
          $this->_db->query();

          return true;
        }
        break;
    }

    return false;
  }

  function change()
  {
    $field  = JRequest::getVar('field',  '', 'GET', 'string');
    $value  = JRequest::getVar('value',  0,  'GET', 'integer');
    $id     = JRequest::getVar('id',     0,  'GET', 'integer');
    $source = JRequest::getVar('source', '', 'GET', 'string');

    if (!in_array($field, array('approved')) && !in_array($source, array('lovefactory', 'hotornot')))
    {
      return false;
    }

    switch ($source)
    {
      case 'lovefactory':
        // Check if the picture has bridge in hotornot
        $query = ' SELECT i.*'
               . ' FROM #__hotornot_image_lovefactory i'
               . ' WHERE image_id = ' . $id;
        $this->_db->setQuery($query);
        $bridge = $this->_db->loadObject();

        if (is_null($bridge))
        {
          $query = ' INSERT'
                 . ' INTO #__hotornot_image_lovefactory (`image_id`, `approved`)'
                 . ' VALUES (' . $id . ', ' . $value . ')';
          $this->_db->setQuery($query);
          $this->_db->query();

          return true;
        }

        $query = ' UPDATE #__hotornot_image_lovefactory'
               . ' SET ' . $field . ' = ' . $value
               . ' WHERE image_id = ' . $id;
      break;

      case 'hotornot':
        $query = ' UPDATE #__hotornot_image'
               . ' SET ' . $field . ' = ' . $value
               . ' WHERE id = ' . $id;
      break;
    }
    $this->_db->setQuery($query);
    $this->_db->query();

    require_once(JPATH_COMPONENT_ADMINISTRATOR.DS.'settings.php');
    $settings = new HNConfig();

    if ($value == 1 && $settings->enable_notification_new_image_approved)
    {
      // send notification
      $this->sendNotification($id, $source);
    }

    return true;
  }

  function publish()
  {
    require_once(JPATH_COMPONENT_SITE.DS.'helper.php');

    $cids = JRequest::getVar('cid', array(0), 'post', 'array');
    JRequest::setVar('field', 'approved', 'GET', true);
    JRequest::setVar('value', 1, 'GET', true);

    if (Helper::getPhotoSource() == 0)
    {
      JRequest::setVar('source', 'hotornot', 'GET', true);
    }
    else
    {
      JRequest::setVar('source', 'lovefactory', 'GET', true);
    }

    foreach ($cids as $cid)
    {
      JRequest::setVar('id', $cid, 'GET', true);

      if (!$this->change())
      {
        $this->setError($field->getErrorMsg());
        return false;
      }
    }

    return true;
  }

  function unpublish()
  {
    require_once(JPATH_COMPONENT_SITE.DS.'helper.php');

    $cids = JRequest::getVar('cid', array(0), 'post', 'array');
    JRequest::setVar('field', 'approved', 'GET', true);
    JRequest::setVar('value', 0, 'GET', true);

    if (Helper::getPhotoSource() == 0)
    {
      JRequest::setVar('source', 'hotornot', 'GET', true);
    }
    else
    {
      JRequest::setVar('source', 'lovefactory', 'GET', true);
    }

    foreach ($cids as $cid)
    {
      JRequest::setVar('id', $cid, 'GET', true);

      if (!$this->change())
      {
        $this->setError($field->getErrorMsg());
        return false;
      }
    }

    return true;
  }

  // Helpers
  function sendNotification($image_id, $source)
  {
    $settings = new HNConfig();

    $subject = base64_decode($settings->notification_new_image_approved_subject);
    $message = base64_decode($settings->notification_new_image_approved_message);

    if (!$settings->enable_html_emails)
    {
      $image_link = JURI::root() .'index.php?option=com_hotornot&task=show&id=' . $image_id . '&source=' . $source;
    }
    else
    {
      $url = JURI::root() .'index.php?option=com_hotornot&task=show&id=' . $image_id . '&source=' . $source;
      $image_link = '<a href="' . $url . '">' . $url . '</a>';
    }

    $search  = array('%%imagelink%%');
    $replace = array($image_link);

    $subject = str_ireplace($search, $replace, $subject);
    $message = str_ireplace($search, $replace, $message);

    if ($settings->enable_html_emails)
    {
      $subject = nl2br($subject);
      $message = nl2br($message);
    }

    // Get the receiver
    if ($source == 'hotornot')
    {
      $query = ' SELECT i.user_id'
             . ' FROM #__hotornot_image i'
             . ' WHERE i.id = ' . $image_id;
    }
    else
    {
      $query = ' SELECT p.user_id'
             . ' FROM #__lovefactory_photos p'
             . ' WHERE p.id = ' . $image_id;
    }
    $this->_db->setQuery($query);
    $user_id = $this->_db->loadResult();
    $receiver =& JFactory::getUser($user_id);

    if (!is_null($receiver->email))
    {
      // Send the mail
      $mail =& JFactory::getMailer();
      $mail->addRecipient($receiver->email);

      $mail->setSubject(JText::_($subject));
      $mail->setBody(JText::_($message));

      $mail->IsHTML($settings->enable_html_emails);

      $mail->send();
    }
  }
}