<?php

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');

class BackendModelImages extends JModel
{
  var $_data;
  var $_total;
  var $_pagination;

  function __construct()
  {
    parent::__construct();

    global $mainframe, $option;
    $limit      = $mainframe->getUserStateFromRequest('global.list.limit',     'limit',      $mainframe->getCfg('list_limit'), 'int');
    $limitstart = $mainframe->getUserStateFromRequest($option . '.limitstart', 'limitstart', 0,                                'int');

    $limitstart = ($limit != 0 ? (floor($limitstart / $limit) * $limit) : 0);

    $this->setState('limit', $limit);
    $this->setState('limitstart', $limitstart);
  }

  function getData()
  {
    if (empty($this->_data))
    {
      $query = $this->_buildQuery();
      $this->_data = $this->_getList($query, $this->getState('limitstart'), $this->getState('limit'));
    }

    return $this->_data;
  }

  function _buildQuery()
  {
    $where = $this->_buildWhereCondition();

    require_once(JPATH_COMPONENT_SITE.DS.'helper.php');
    $hotornot = ' SELECT i.id, i.extension, i.folder, i.hits, i.rank, i.user_id, "hotornot" AS source, i.approved, c.title AS category'
              . ' FROM #__hotornot_image i'
              . ' LEFT JOIN #__users u ON u.id = i.user_id'
              . ' LEFT JOIN #__hotornot_categories c ON c.id = i.category_id'
              . $where;

    $lovefactory = ' SELECT p.id, p.filename AS extension, "" AS folder, i.hits, i.rank, p.user_id, "lovefactory" AS source, i.approved, "" AS category'
                 . ' FROM #__lovefactory_photos p'
                 . ' LEFT JOIN #__hotornot_image_lovefactory i ON p.id = i.image_id'
                 . ' LEFT JOIN #__users u ON u.id = p.user_id'
                 . $where;

    switch (Helper::getPhotoSource())
    {
      case 0:
        $query = $hotornot;
      break;

      case 1:
        $query = ' (' . $hotornot . ')'
               . ' UNION'
               . ' (' . $lovefactory . ')';
      break;

      case 2:
        $query = $lovefactory;
      break;
    }

    return $query;
  }

  function _buildWhereCondition()
  {
    global $mainframe, $option;

    $approved = $mainframe->getUserStateFromRequest($option . '.images.approved', 'approved', '', 'cmd');
    $where    = '';

    if ($approved != '')
    {
      $approved  = intval($approved);
      $where    .= ' WHERE i.approved = ' . $approved;
    }

    return $where;
  }

  function getTotal()
  {
    if (empty($this->_total))
    {
      $query = $this->_buildQuery();
      $this->_total = $this->_getListCount($query);
    }

    return $this->_total;
  }

  function getPagination()
  {
    if (empty($this->_pagination))
    {
      jimport('joomla.html.pagination');
      $this->_pagination = new JPagination($this->getTotal(), $this->getState('limitstart'), $this->getState('limit'));
    }

    return $this->_pagination;
  }

  function getTags()
  {
    $list = array(
      'hotornot'    => array(),
      'lovefactory' => array()
    );

    foreach ($this->_data as $image)
    {
      if ($image->source == 'hotornot')
      {
        $query = ' SELECT *'
               . ' FROM #__hotornot_tag'
               . ' WHERE image_id = ' . $image->id;
        $this->_db->setQuery($query);
        $tags = $this->_db->loadObjectList();

        $array = array();
        foreach ($tags as $tag)
        {
          $array[] = $tag->name;
        }

        $list['hotornot'][$image->id] = implode(', ', $array);
      }
      else
      {
        $list['lovefactory'][$image->id] = '';
      }
    }

    return $list;
  }
}