<?php

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');

class BackendModelReports extends JModel
{
  var $_total_images;
  var $_total_comments;
  var $_limitstart;
  var $_items_per_page;

  function __construct()
  {
    $this->_items_per_page = 10;
    $this->_limitstart =  JRequest::getVar('limitstart', 0, 'GET', 'integer');

    parent::__construct();
  }

  function getCountReports()
  {
    return array(
      'comments' => $this->getCountReportsComments(),
      'images'   => $this->getCountReportsImages(),
    );
  }

  function getCountReportsImages()
  {
    if (isset($this->_total_images))
    {
      return $this->_total_images;
    }

    $database =& JFactory::getDBO();

    $query = ' SELECT COUNT(id)'
           . ' FROM #__hotornot_report';
    $database->setQuery($query);
    $images = $database->loadResult();

    return $images;
  }

  function getCountReportsComments()
  {
    if (isset($this->_total_comments))
    {
      return $this->_total_comments;
    }

    $database =& JFactory::getDBO();

    $query = ' SELECT COUNT(id)'
           . ' FROM #__hotornot_comment'
           . ' WHERE reports';
    $database->setQuery($query);
    $comments = $database->loadResult();

    return $comments;
  }

  function getReportsImages()
  {
    $database =& JFactory::getDBO();
    require_once(JPATH_COMPONENT_SITE.DS.'helper.php');

    $hotornot = ' SELECT i.id, 0 AS user_id, i.folder, i.extension, i.description, r.name, r.email, r.message, r.date_added, r.id AS report_id, "hotornot" AS source'
              . ' FROM #__hotornot_report r'
              . ' LEFT JOIN #__hotornot_image i ON i.id = r.image_id'
              . ' WHERE r.source = "hotornot"';

    $lovefactory = ' SELECT p.id, p.user_id, "" AS folder, p.filename AS extension, "" AS description, r.name, r.email, r.message, r.date_added, r.id AS report_id, "lovefactory" AS source'
                 . ' FROM #__hotornot_report r'
                 . ' LEFT JOIN #__lovefactory_photos p ON p.id = r.image_id'
                 . ' WHERE r.source = "lovefactory"';

    switch (Helper::getPhotoSource())
    {
      case 0:
        $query = $hotornot;
      break;

      case 1:
        $query = ' (' . $hotornot . ')'
               . ' UNION'
               . ' (' . $lovefactory . ')';
      break;

      case 2:
        $query = $lovefactory;
      break;
    }

    $query .= ' ORDER BY date_added DESC';

    $images = $this->_getList($query, $this->_limitstart, $this->_items_per_page);

    return $images;
  }

  function getReportsComments()
  {
    $database =& JFactory::getDBO();

    $query = ' SELECT c.id, c.reports, c.comment'
           . ' FROM #__hotornot_comment c'
           . ' WHERE reports'
           . ' ORDER BY reports DESC';

    $images = $this->_getList($query, $this->_limitstart, $this->_items_per_page);

    return $images;
  }

  function getPaginationImages()
  {
    jimport('joomla.html.pagination');

    $pagination = new JPagination($this->getCountReportsImages(), $this->_limitstart, $this->_items_per_page);
    return $pagination;
  }

  function getPaginationComments()
  {
    jimport('joomla.html.pagination');

    $pagination = new JPagination($this->getCountReportsComments(), $this->_limitstart, $this->_items_per_page);
    return $pagination;
  }
}