<?php

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');

class BackendModelSettings extends JModel
{
  var $_file;
  var $_settings;
  var $_old_scale_top;
  var $_old_upload_folder;

  function __construct()
  {
    $this->_file = JPATH_BASE.DS.'components'.DS.'com_hotornot'.DS.'settings.php';
    require_once($this->_file);

    $this->_settings = new HNConfig();

    $this->_old_scale_top     = $this->_settings->scale_top;
    $this->_old_upload_folder = $this->_settings->upload_folder;

    parent::__construct();
  }

  function getSettings()
  {
    return new HNConfig();
  }

  function store()
  {
    $this->updateSettings();

    $this->checkScaleTop();
    $this->checkUploadFolder();

    $this->writeSettings();
  }

  function updateSettings()
  {
    // Global
    $this->_settings->allow_guest_voting        = JRequest::getVar('allow_guest_voting',        $this->_settings->allow_guest_voting,        'POST', 'integer');
    $this->_settings->allow_guest_uploading     = JRequest::getVar('allow_guest_uploading',     $this->_settings->allow_guest_uploading,     'POST', 'integer');
    $this->_settings->scale_top                 = JRequest::getVar('scale_top',                 $this->_settings->scale_top,                 'POST', 'integer');
    $this->_settings->upload_folder             = base64_encode(JRequest::getVar('upload_folder', $this->_settings->upload_folder,           'POST', 'string'));
    $this->_settings->max_top_show              = JRequest::getVar('max_top_show',              $this->_settings->max_top_show,              'POST', 'integer');
    $this->_settings->top_images_per_page       = JRequest::getVar('top_images_per_page',       $this->_settings->top_images_per_page,       'POST', 'integer');
    $this->_settings->max_uploads               = JRequest::getVar('max_uploads',               $this->_settings->max_uploads,               'POST', 'integer');
    $this->_settings->voting_interval           = JRequest::getVar('voting_interval',           $this->_settings->voting_interval,           'POST', 'integer');
    $this->_settings->min_top_votes             = JRequest::getVar('min_top_votes',             $this->_settings->min_top_votes,             'POST', 'integer');
    $this->_settings->enable_html_emails        = JRequest::getVar('enable_html_emails',        $this->_settings->enable_html_emails,        'POST', 'integer');
    $this->_settings->enable_watermark          = JRequest::getVar('enable_watermark',          $this->_settings->enable_watermark,          'POST', 'integer');

    $this->_settings->enable_comments_approval_system = JRequest::getVar('enable_comments_approval_system', $this->_settings->enable_comments_approval_system, 'POST', 'integer');
    $this->_settings->enable_image_approval_system    = JRequest::getVar('enable_image_approval_system',    $this->_settings->enable_image_approval_system,    'POST', 'integer');
    $this->_settings->enable_new_comment_notification = JRequest::getVar('enable_new_comment_notification', $this->_settings->enable_new_comment_notification, 'POST', 'integer');
    $this->_settings->allow_users_delete_photos       = JRequest::getVar('allow_users_delete_photos',       $this->_settings->allow_users_delete_photos,       'POST', 'integer');

    $this->_settings->notification_new_image_uploaded_receivers = JRequest::getVar('notification_new_image_uploaded_receivers', array(), 'POST', 'array');

    $this->_settings->enable_notification_new_image_uploaded = JRequest::getVar('enable_notification_new_image_uploaded', $this->_settings->enable_notification_new_image_uploaded, 'POST', 'integer');
    $this->_settings->enable_notification_new_image_approved = JRequest::getVar('enable_notification_new_image_approved', $this->_settings->enable_notification_new_image_approved, 'POST', 'integer');

    $this->_settings->notification_new_comment_subject = base64_encode(JRequest::getVar('notification_new_comment_subject', base64_decode($this->_settings->notification_new_comment_subject), 'POST', 'string', 4));
    $this->_settings->notification_new_comment_message = base64_encode(JRequest::getVar('notification_new_comment_message', base64_decode($this->_settings->notification_new_comment_message), 'POST', 'string', 4));

    $this->_settings->notification_new_image_uploaded_subject = base64_encode(JRequest::getVar('notification_new_image_uploaded_subject', base64_decode($this->_settings->notification_new_image_uploaded_subject), 'POST', 'string', 4));
    $this->_settings->notification_new_image_uploaded_message = base64_encode(JRequest::getVar('notification_new_image_uploaded_message', base64_decode($this->_settings->notification_new_image_uploaded_message), 'POST', 'string', 4));

    $this->_settings->notification_new_image_approved_subject = base64_encode(JRequest::getVar('notification_new_image_approved_subject', base64_decode($this->_settings->notification_new_image_approved_subject), 'POST', 'string', 4));
    $this->_settings->notification_new_image_approved_message = base64_encode(JRequest::getVar('notification_new_image_approved_message', base64_decode($this->_settings->notification_new_image_approved_message), 'POST', 'string', 4));

    // Info boxes
    $this->_settings->info_upload_photo = base64_encode(JRequest::getVar('info_upload_photo', base64_decode($this->_settings->info_upload_photo), 'POST', 'string', 4));

    // Image size
    $this->_settings->image_max_width           = JRequest::getVar('image_max_width',           $this->_settings->image_max_width,           'POST', 'integer');
    $this->_settings->image_max_height          = JRequest::getVar('image_max_height',          $this->_settings->image_max_height,          'POST', 'integer');
    $this->_settings->image_min_width           = JRequest::getVar('image_min_width',           $this->_settings->image_min_width,           'POST', 'integer');
    $this->_settings->image_min_height          = JRequest::getVar('image_min_height',          $this->_settings->image_min_height,          'POST', 'integer');

    // Thumbnail size
    $this->_settings->thumbnail_max_width       = JRequest::getVar('thumbnail_max_width',       $this->_settings->thumbnail_max_width,       'POST', 'integer');
    $this->_settings->thumbnail_max_height      = JRequest::getVar('thumbnail_max_height',      $this->_settings->thumbnail_max_height,      'POST', 'integer');

    // Image description
    $this->_settings->allow_image_description   = JRequest::getVar('allow_image_description',   $this->_settings->allow_image_description,   'POST', 'integer');
    $this->_settings->require_image_description = JRequest::getVar('require_image_description', $this->_settings->require_image_description, 'POST', 'integer');
    $this->_settings->max_description_length    = JRequest::getVar('max_description_length',    $this->_settings->max_description_length,    'POST', 'integer');

    // Tags
    $this->_settings->allow_tags                = JRequest::getVar('allow_tags',                $this->_settings->allow_tags,                'POST', 'integer');
    $this->_settings->require_tags              = JRequest::getVar('require_tags',              $this->_settings->require_tags,              'POST', 'integer');
    $this->_settings->max_no_tags               = JRequest::getVar('max_no_tags',               $this->_settings->max_no_tags,               'POST', 'integer');
    $this->_settings->max_cloud_tags            = JRequest::getVar('max_cloud_tags',            $this->_settings->max_cloud_tags,            'POST', 'integer');

    // Comments
    $this->_settings->allow_comments_from       = JRequest::getVar('allow_comments_from',       $this->_settings->allow_comments_from,       'POST', 'integer');
    $this->_settings->display_no_comments       = JRequest::getVar('display_no_comments',       $this->_settings->display_no_comments,       'POST', 'integer');

    // Genre
    $this->_settings->allow_gender              = JRequest::getVar('allow_gender',              $this->_settings->allow_gender,              'POST', 'integer');

    // Email
    $this->_settings->send_email_report         = JRequest::getVar('send_email_report',         $this->_settings->send_email_report,         'POST', 'integer');
    $this->_settings->email_address_report      = JRequest::getVar('email_address_report',      $this->_settings->email_address_report,      'POST', 'string');

    // Love Factory Integration photos_source
    $this->_settings->photos_source             = JRequest::getVar('photos_source',             $this->_settings->photos_source,             'POST', 'integer');

    // Save watermark
    $this->saveWatermark();
  }

  function writeSettings()
  {
    $handle = fopen($this->_file, 'w');
    fwrite($handle, $this->templateSettings());
    fclose($handle);
  }

  function templateSettings()
  {
    $template = '<?php

defined(\'_JEXEC\') or die(\'Restricted access\');

class HNConfig
{
  // Global
  var $allow_guest_voting              = ' . $this->_settings->allow_guest_voting . ';
  var $allow_guest_uploading           = ' . $this->_settings->allow_guest_uploading . ';
  var $scale_top                       = ' . $this->_settings->scale_top . ';
  var $upload_folder                   = "' . $this->_settings->upload_folder . '";
  var $max_top_show                    = ' . $this->_settings->max_top_show . ';
  var $top_images_per_page             = ' . $this->_settings->top_images_per_page . ';
  var $max_uploads                     = ' . $this->_settings->max_uploads . ';
  var $voting_interval                 = ' . $this->_settings->voting_interval . ';
  var $min_top_votes                   = ' . $this->_settings->min_top_votes . ';
  var $enable_comments_approval_system = ' . $this->_settings->enable_comments_approval_system . ';
  var $enable_image_approval_system    = ' . $this->_settings->enable_image_approval_system . ';
  var $enable_new_comment_notification = ' . $this->_settings->enable_new_comment_notification . ';
  var $enable_html_emails              = ' . $this->_settings->enable_html_emails . ';
  var $enable_watermark                = ' . $this->_settings->enable_watermark . ';
  var $allow_users_delete_photos       = ' . $this->_settings->allow_users_delete_photos . ';

  var $notification_new_image_uploaded_receivers = array(' . implode(',', $this->_settings->notification_new_image_uploaded_receivers) . ');

  var $enable_notification_new_image_approved = ' . $this->_settings->enable_notification_new_image_approved . ';
  var $enable_notification_new_image_uploaded = ' . $this->_settings->enable_notification_new_image_uploaded . ';

  var $notification_new_comment_subject = "' . $this->_settings->notification_new_comment_subject . '";
  var $notification_new_comment_message = "' . $this->_settings->notification_new_comment_message . '";

  var $notification_new_image_uploaded_subject = "' . $this->_settings->notification_new_image_uploaded_subject . '";
  var $notification_new_image_uploaded_message = "' . $this->_settings->notification_new_image_uploaded_message . '";

  var $notification_new_image_approved_subject = "' . $this->_settings->notification_new_image_approved_subject . '";
  var $notification_new_image_approved_message = "' . $this->_settings->notification_new_image_approved_message . '";

  // Info boxes
  var $info_upload_photo = "' . $this->_settings->info_upload_photo . '";

  // Image size
  var $image_max_width           = ' . $this->_settings->image_max_width . ';
  var $image_max_height          = ' . $this->_settings->image_max_height . ';
  var $image_min_width           = ' . $this->_settings->image_min_width . ';
  var $image_min_height          = ' . $this->_settings->image_min_height . ';

  // Thumbnail size
  var $thumbnail_max_width       = ' . $this->_settings->thumbnail_max_width . ';
  var $thumbnail_max_height      = ' . $this->_settings->thumbnail_max_height . ';

  // Image description
  var $allow_image_description   = ' . $this->_settings->allow_image_description . ';
  var $require_image_description = ' . $this->_settings->require_image_description . ';
  var $max_description_length    = ' . $this->_settings->max_description_length . ';

  // Tags
  var $allow_tags                = ' . $this->_settings->allow_tags . ';
  var $require_tags              = ' . $this->_settings->require_tags . ';
  var $max_no_tags               = ' . $this->_settings->max_no_tags . ';
  var $max_cloud_tags            = ' . $this->_settings->max_cloud_tags . ';

  // Comments
  var $allow_comments_from       = ' . $this->_settings->allow_comments_from . ';
  var $display_no_comments       = ' . $this->_settings->display_no_comments . ';

  // Genre
  var $allow_gender              = ' . $this->_settings->allow_gender . ';

  // Email
  var $send_email_report         = ' . $this->_settings->send_email_report . ';
  var $email_address_report      = "' . $this->_settings->email_address_report . '";

  // Love Factory Integration
  var $photos_source             = ' . $this->_settings->photos_source . ';

  // Watermark
  var $watermark_path            = "' . $this->_settings->watermark_path . '";
  var $watermark_position_x      = ' . $this->_settings->watermark_position_x . ';
  var $watermark_position_y      = ' . $this->_settings->watermark_position_y . ';
  var $watermark_margin          = ' . $this->_settings->watermark_margin . ';
}';

    return $template;
  }

  function checkScaleTop()
  {
    if ($this->_settings->scale_top != $this->_old_scale_top)
    {
      ($this->_old_scale_top > $this->_settings->scale_top) ? $multiply_factor = 0.5 : $multiply_factor = 2;

      $database =& JFactory::getDBO();
      $query = ' UPDATE #__hotornot_image'
             . ' SET rank = rank * ' . $multiply_factor;
      $database->setQuery($query);
      $database->query();
    }
  }

  function checkUploadFolder()
  {
    require_once(JPATH_ROOT.DS.'components'.DS.'com_hotornot'.DS.'helper.php');
    require_once(JPATH_BASE.DS.'components'.DS.'com_hotornot'.DS.'fcounter.php');

    if ($this->_old_upload_folder != $this->_settings->upload_folder)
    {
      $path = Helper::decodePath($this->_old_upload_folder);
      $new  = Helper::decodePath($this->_settings->upload_folder);
      $counter = new HNCounter();

      if ($handle = opendir($path))
      {
        while (false !== ($file = readdir($handle)))
        {
          if ((is_dir($path.DS.$file)) &&
              ((int)$file <= $counter->current_folder) &&
              (is_numeric($file)))
          {
            rename($path.DS.$file, $new.DS.$file);
          }
        }

        closedir($handle);
      }
    }
  }

  function getLoveFactoryIntegration()
  {
    $query = ' SELECT COUNT(id)'
           . ' FROM #__components'
           . ' WHERE link = "option=com_lovefactory"';
    $this->_db->setQuery($query);

    return (boolean)$this->_db->loadResult();
  }

  function getAdmins()
  {
    $query = ' SELECT u.id, u.username'
           . ' FROM #__users u'
           . ' WHERE u.gid IN (24, 25)';
    $this->_db->setQuery($query);
    return $this->_db->loadObjectList();
  }

  function saveWatermark()
  {
    // Check if the watermark is enabled
    if (!$this->_settings->enable_watermark)
    {
      return false;
    }

    jimport('joomla.filesystem.file');

    // Delete the old watermark if checked
    $delete_watermark =& JRequest::getVar('delete_watermark', '', 'POST', 'string');

    if ($delete_watermark == 'on' && !empty($this->_settings->watermark_path))
    {
      JFile::delete(JPATH_COMPONENT_SITE.DS.'upload'.DS.'watermark'.DS.$this->_settings->watermark_path);
      $this->_settings->watermark_path = '';
    }

    // Upload the new watermark
    $watermark =& JRequest::getVar('watermark', array(), 'FILES', 'array');

    if ($watermark['error'] != 4)
    {
      // Check for errors when uploading
      if ($watermark['error'])
      {
        $this->setError(JText::_('Error ' . $watermark['error'] . ' when uploading the image.'));
      }
      else
      {
        // Check if file is an image
        if (!in_array($watermark['type'], array('image/jpeg', 'image/jpg', 'image/gif', 'image/png')))
        {
          $this->setError(JText::_('Uploaded file is not an image.'));
        }
        else
        {
          // Delete the old watermark
          if (!empty($this->_settings->watermark_path))
          {
            JFile::delete(JPATH_COMPONENT_SITE.DS.'upload'.DS.'watermark'.DS.$this->_settings->watermark_path);
            $this->_settings->watermark_path = '';
          }

          // Move the new watermark
          if (JFile::move($watermark['tmp_name'], JPATH_COMPONENT_SITE.DS.'upload'.DS.'watermark'.DS.$watermark['name']))
          {
            $this->_settings->watermark_path = $watermark['name'];
          }
        }
      }
    }

    // Save the position
    $this->_settings->watermark_position_y =& JRequest::getVar('watermark_position_y', $this->_settings->watermark_position_y, 'POST', 'integer');
    $this->_settings->watermark_position_x =& JRequest::getVar('watermark_position_x', $this->_settings->watermark_position_x, 'POST', 'integer');

    // Save the distance from margins
    $this->_settings->watermark_margin =& JRequest::getVar('watermark_margin', $this->_settings->watermark_margin, 'POST', 'integer');
  }
}