function MultiSelector( list_target, max ){

	// Where to write the list
	this.list_target = list_target;
	// How many elements?
	this.count = 0;
	// How many elements?
	this.id = 0;
	// Is there a maximum?
	if( max ){
		this.max = max;
	} else {
		this.max = -1;
	};

	/**
	 * Add a new file input element
	 */
	this.addElement = function( element ){

		// Make sure it's a file input element
		if( element.tagName == 'INPUT' && element.type == 'file' ){

			// Element name -- what number am I?
			element.name = 'file_' + this.id++;

			// Add reference to this object
			element.multi_selector = this;

			// What to do when a file is selected
			element.onchange = function(){

				// New file input
				var new_element = document.createElement( 'input' );
				new_element.type = 'file';

				// Add new element
				this.parentNode.insertBefore( new_element, this );

				// Apply 'update' to element
				this.multi_selector.addElement( new_element );

				// Update list
				this.multi_selector.addListRow( this );

				// Hide this: we can't use display:none because Safari doesn't like it
				this.style.position = 'absolute';
				this.style.left = '-1000px';

			};
			// If we've reached maximum number, disable input element
			if( this.max != -1 && this.count >= this.max ){
				element.disabled = true;
			};

			// File element counter
			this.count++;
			// Most recent element
			this.current_element = element;

		} else {
			// This can only be applied to file input elements!
			alert( 'Error: not a file input element' );
		};

	};

	/**
	 * Add a new row to the list of files
	 */
	this.addListRow = function( element ){

		// Row div
		var new_row = document.createElement( 'div' );

		// Delete button
		var new_row_button = document.createElement( 'input' );
		new_row_button.type = 'button';
		new_row_button.value = 'Delete';

		img_del = document.createElement('img');
		img_del.src = root+'components/com_hotornot/assets/images/delete.png';
		img_del.className = 'hotornot-icon2';

		new_row_button = document.createElement('a')
		new_row_button.innerHTML = text_delete;
		new_row_button.href = '#';

		// References
		new_row.element = element;

		// Delete function
		new_row_button.onclick= function(){

		  var parent = this.parentNode.parentNode.parentNode.parentNode;

			// Remove element from form
			parent.parentNode.element.parentNode.removeChild( parent.parentNode.element );

			// Remove this row from the list
			parent.parentNode.parentNode.removeChild( parent.parentNode );

			// Decrement counter
			parent.parentNode.element.multi_selector.count--;

			// Re-enable input element (if it's disabled)
			parent.parentNode.element.multi_selector.current_element.disabled = false;

			// Appease Safari
			//    without it Safari wants to reload the browser window
			//    which nixes your already queued uploads
			return false;
		};

		table = document.createElement('table');
		table.className = 'hotornot-upload-table';
		table.id = 'hotornot-upload-' + this.count;
		tbody = document.createElement('tbody');
		tr    = document.createElement('tr');
		td    = document.createElement('td');
		td.colSpan = 2;
		td.className = 'hotornot-upload-file-name'
		b = document.createElement('b');
		b.appendChild(document.createTextNode(element.value))
		td.appendChild(document.createTextNode(text_photo + ': '));
		td.appendChild(b);
		tr.appendChild(td);
		tbody.appendChild(tr);

		// Image description
		if (allow_image_description)
		{
		  tr = document.createElement('tr');
		  td = document.createElement('td');
		  label = document.createElement('label');
		  label_text = document.createTextNode(text_description);
		  label.htmlFor = 'description_' + (this.count-2);
		  label.appendChild(label_text);

		  if (require_image_description)
		  {
		    img = document.createElement('img');
		    img.className = 'hotornot-icon2';
		    img.src = root + 'components/com_hotornot/assets/images/exclamation.png';
		    label.appendChild(img);
		  }

		  td.appendChild(label);
		  tr.appendChild(td);

		  td = document.createElement('td');

		  textarea = document.createElement('textarea');
		  textarea.id = 'description_' + (this.count-2);
		  textarea.name = 'description_' + (this.count-2);
		  textarea.rel = (this.count-2);
		  textarea.onkeyup = function () {
		    var length = this.value.length;

		    if (max_description_length - length < 0)
        {
          this.value = this.value.substr(0, max_description_length);
          document.getElementById('description-update_' + this.rel).innerHTML = 0;
        }
        else
        {
          document.getElementById('description-update_' + this.rel).innerHTML = max_description_length - length;
        }
		  }
		  textarea.onclick = function () {
		    this.className = '';
		  }

		  td.appendChild(textarea);

		  div = document.createElement('div');
		  span = document.createElement('span');
		  span.appendChild(document.createTextNode(max_description_length));
		  span.id = 'description-update_' + (this.count-2);

		  div.appendChild(span);
		  div.appendChild(document.createTextNode(' ' + text_chars_remaining));
		  td.appendChild(div);

		  tr.appendChild(td);
		  tbody.appendChild(tr);
		}

		// Allow gender
		if (allow_gender)
		{
		  var category = document.getElementById('category');
		  var clone = category.cloneNode(true);

		  clone.id   = 'category_' + (this.count - 2);
		  clone.name = 'category_' + (this.count - 2);

		  clone.selectedIndex = category.selectedIndex;

		  tr = document.createElement('tr');
		  td = document.createElement('td');

		  label           = document.createElement('label');
		  label.htmlFor   = 'category_' + (this.count - 2);
		  label.innerHTML = text_category + ':';

		  td.appendChild(label);

		  tr.appendChild(td);
		  td = document.createElement('td');

		  td.appendChild(clone);

		  tr.appendChild(td);
		  tbody.appendChild(tr);
		}

		// Allow tags
		if (allow_tags)
		{
		  tr = document.createElement('tr');
		  td = document.createElement('td');
		  label = document.createElement('label');
		  label_text = document.createTextNode(text_tags);
		  label.htmlFor = 'tags_' + (this.count-2);
		  label.appendChild(label_text);

		  if (require_tags)
		  {
		    img = document.createElement('img');
		    img.className = 'hotornot-icon2';
		    img.src = root + 'components/com_hotornot/assets/images/exclamation.png';
		    label.appendChild(img);
		  }

		  td.appendChild(label);
		  tr.appendChild(td);

		  td = document.createElement('td');

		  input = document.createElement('input');
		  input.type = 'text';
		  input.id = 'tags_'+(this.count-2);
		  input.name = 'tags_'+(this.count-2);
		  input.rel = (this.count-2);

		  input.onkeyup = function () {
		    var length = this.value.split(',').length;

        if (max_no_tags - length < 0)
        {
          var new_tags = '';
          var tags = this.value.split(',');

          for (i = 0; i < max_no_tags; i++)
          {
            new_tags += tags[i].replace(/^\s+|\s+$/g,"");
            if (i < max_no_tags - 1)
            {
              new_tags += ', ';
            }
          }

          this.value = new_tags;
          document.getElementById('tags-update_'+this.rel).innerHTML = 0;
        }
        else
        {
          document.getElementById('tags-update_'+this.rel).innerHTML = max_no_tags - length;
        }
		  }
		  input.onclick = function () {
		    this.className = '';
		  }

		  td.appendChild(input);

		  div = document.createElement('div');
		  span = document.createElement('span');
		  span.appendChild(document.createTextNode(max_no_tags));
		  span.id = 'tags-update_' + (this.count-2);

		  div.appendChild(span);
		  div.appendChild(document.createTextNode(' ' + text_tags_remaining));
		  td.appendChild(div);

		  tr.appendChild(td);
		  tbody.appendChild(tr);
		}

		tr = document.createElement('tr');
		td = document.createElement('td');
		td.colSpan = 2;
		td.className = 'hotornot-delete-button';
		td.appendChild(img_del);
		td.appendChild(new_row_button);
		tr.appendChild(td);
		tbody.appendChild(tr);

		table.appendChild(tbody);
		new_row.appendChild(table);

		// Add it to the list
		if (this.list_target.childNodes.length > 0)
		{
		  var last_row = list_target.childNodes[0];
		  this.list_target.insertBefore(new_row, last_row);
		}
		else
		{
		  this.list_target.appendChild(new_row);
		}

		//jQuery('#hotornot-upload-' + this.count).effect('highlight', {}, 3000);
	};

};