<?php

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.controller');

class FrontendController extends JController
{
  function __construct()
  {
    require_once('helper.php');
    require_once(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_hotornot'.DS.'settings.php');
    require_once(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_hotornot'.DS.'fcounter.php');

    parent::__construct();
  }

  function display()
  {
    $views = array('latest', 'managecomments', 'upload', 'show');
    if (in_array(JRequest::getVar('view', '', 'GET', 'string'), $views))
    {
      parent::display();
      return true;
    }

    $view  =& $this->getView('show', 'html');
    $model =& $this->getModel('show');

    $view->setModel($model, true);
    $view->display();
  }

  function vote()
  {
    if (JRequest::getMethod() != 'POST')
    {
      $this->display();
      return false;
    }

    // Get the model
    $model =& $this->getModel('vote');
    $msg   =  JText::_('Vote registered successfuly!');

    // Register voter
    if ($model->registerVoter())
    {
      // Register vote
      if (!$model->registerVote())
      {
        JError::raiseWarning('ERROR', JText::_('Error registering vote!'));
        $msg = JText::_('Vote not registered!');
      }
    }
    else
    {
      JError::raiseWarning('ERROR', JText::_('Error registering voter!'));
      $msg = JText::_('Vote not registered!');
    }

    global $mainframe, $Itemid;

    $mainframe->redirect('index.php?option=com_hotornot&Itemid=' . $Itemid, $msg);
  }

  function report()
  {
    $view  =& $this->getView('report', 'html');

    if (JRequest::getMethod() == 'POST')
    {
      $model =& $this->getModel('report');
      $view->setModel($model, true);

      $view->report();
    }
    else
    {
      $type = JRequest::getVar('type', 0, 'GET', 'integer');
      if ($type == 1)
      {
        $view->display();
      }
    }
  }

  function delete()
  {
    $view  =& $this->getView('delete', 'html');
    $model =& $this->getModel('delete');

    $view->setModel($model, true);
    $view->display();
  }

  function comments()
  {
    $view  =& $this->getView('comments', 'html');
    $model =& $this->getModel('comments');

    $view->setModel($model, true);
    $view->display();
  }

  function comment()
  {
    if (JRequest::getMethod() != 'POST')
    {
      return false;
    }

    $view  =& $this->getView('comment', 'html');
    $model =& $this->getModel('comment');

    $view->setModel($model, true);
    $view->display();
  }

  function category()
  {
    $category = JRequest::getVar('id', -1, 'GET', 'integer');

    setcookie('category', $category, time() + 86400);

    global $mainframe, $Itemid;

    $mainframe->redirect('index.php?option=com_hotornot&Itemid=' . $Itemid);
  }

  function top()
  {
    $view  =& $this->getView('browse', 'html');
    $model =& $this->getModel('browse');
    $model->setParameters(array(
      'type' => 'top'
    ));

    $view->setModel($model, true);
    $view->display('top');
  }

  function mypictures()
  {
    $view  =& $this->getView('browse', 'html');
    $model =& $this->getModel('browse');
    $model->setParameters(array(
      'type' => 'mypictures'
    ));

    $view->setModel($model, true);
    $view->display('mypictures');
  }

  function userpictures()
  {
    $view  =& $this->getView('browse', 'html');
    $model =& $this->getModel('browse');

    $model->setParameters(array(
      'type' => 'userpictures'
    ));

    $view->setModel($model, true);
    $view->display('userpictures');
  }

  function categorypictures()
  {
    $view  =& $this->getView('browse', 'html');
    $model =& $this->getModel('browse');

    $model->setParameters(array(
      'type' => 'categorypictures'
    ));

    $view->setModel($model, true);
    $view->display('categorypictures');
  }

  function upload()
  {
    if (JRequest::getMethod() != 'POST')
    {
      $view  =& $this->getView('upload', 'html');
      $model =& $this->getModel('upload');

      $view->setModel($model, true);

      $tpl = null;

      if (!Helper::canUpload())
      {
        global $Itemid;
        $this->setRedirect(sprintf('index.php?option=com_user&view=login&Itemid=%s', $Itemid));

        $tpl = 'no_upload';
      }

      $view->display($tpl);
    }
    else
    {
      $view =& $this->getView('upload', 'html');

      if (Helper::canUpload())
      {
        $files = JRequest::get('files');
        if (count($files))
        {
          $model =& $this->getModel('upload');
          $view->setModel($model, true);
          $view->upload();
          return true;
        }
        else
        {
          $view->display('too_large');

          return false;
        }
      }

      $view->display('no_upload');
    }
  }

  function search()
  {
    $view  =& $this->getView('browse', 'html');
    $model =& $this->getModel('browse');
    $model->setParameters(array(
      'type'         => 'search',
      'search_type'  => JRequest::getVar('type', 0, 'GET', 'integer'),
      'search_query' => JRequest::getVar('search_query', '', 'GET', 'string'),
    ));

    $view->setModel($model, true);
    $view->display('search');
  }

  function latest()
  {
    $view  =& $this->getView('latest', 'html');
    $model =& $this->getModel('latest');

    $view->setModel($model, true);
    $view->display();
  }

  function managecomments()
  {
    if ($_SERVER['REQUEST_METHOD'] == 'POST')
    {
      $action =& JRequest::getVar('action', '', 'POST', 'string');

      if (in_array($action, array('approve', 'delete')))
      {
        $model = $this->getModel('managecomments');

        if ($model->executeBulk())
        {
          $msg = JText::_('Operation succesful!');
        }
        else
        {
          $msg = JText::_('Operation failed!');
        }

        global $mainframe;
        $mainframe->redirect(JRoute::_('index.php?option=com_hotornot&task=managecomments'), $msg);
      }
    }

    $view  =& $this->getView('managecomments', 'html');
    $model =& $this->getModel('managecomments');

    $view->setModel($model, true);
    $view->display();
  }

  function approvecomment()
  {
    $model =& $this->getModel('managecomments');

    if ($model->approve())
    {
      $msg = JText::_('Comment approved succesfully!');
    }
    else
    {
      $msg = JText::_('Error approving comment!');
    }

    global $mainframe;
    $mainframe->redirect(JRoute::_('index.php?option=com_hotornot&task=managecomments'), $msg);
  }

  function deletecomment()
  {
    $model =& $this->getModel('managecomments');

    if ($model->delete())
    {
      $msg = JText::_('Comment deleted succesfully!');
    }
    else
    {
      $msg = JText::_('Error deleting comment!');
    }

    global $mainframe;
    $mainframe->redirect(JRoute::_('index.php?option=com_hotornot&task=managecomments'), $msg);
  }

  function deleteimage()
  {
    global $Itemid;
    $settings =  new HNConfig();
    $user     =& JFactory::getUser();

    if ($user->guest)
    {
      $msg = JText::_('You must login');
      $this->setRedirect(JRoute::_('index.php?option=com_hotornot&task=mypictures&Itemid=' . $Itemid), $msg);
    }

    if (!$settings->allow_users_delete_photos)
    {
      $msg = JText::_('You are not allowed to delete photos');
      $this->setRedirect(JRoute::_('index.php?option=com_hotornot&task=mypictures&Itemid=' . $Itemid), $msg);
    }

    $model =& $this->getModel('image');
    if ($model->deleteByOwner())
    {
      $msg = JText::_('Photo deleted!');
    }
    else
    {
      $msg = JText::_('Error deleting photo:') . ' ' . $model->getError();
    }

    $this->setRedirect(JRoute::_('index.php?option=com_hotornot&task=mypictures&Itemid=' . $Itemid), $msg);
  }
}