<?php

defined('_JEXEC') or die('Restricted access');

class Helper
{
  function isAdmin()
  {
    $acl  =& JFactory::getACL();
    $user =& JFactory::getUser();

    return $acl->is_group_child_of($user->usertype, 'Public Backend');
  }

  function allowedToVote()
  {
    $params =  new HNConfig();
    $user   =& JFactory::getUser();

    if (($user->id > 0) || ($params->allow_guest_voting))
    {
      return true;
    }

    return false;
  }

  function canComment()
  {
    $params              =  new HNConfig();
    $user                =& JFactory::getUser();
    $allow_comments_from =  $params->allow_comments_from;
    $is_guest            =  $user->guest;

    if (!$allow_comments_from)
    {
      return false;
    }

    if (($allow_comments_from == 1) &&
         ($is_guest))
    {
      return false;
    }

    return true;
  }

  function canUpload()
  {
    $params                =  new HNConfig();
    $user                  =& JFactory::getUser();
    $allow_guest_uploading =  $params->allow_guest_uploading;
    $is_guest              =  $user->guest;

    if ($is_guest && !$allow_guest_uploading)
    {
      return false;
    }

    return true;
  }

  function validUpload()
  {
    $errors = array();
    $params = new HNConfig();

    // Image description check
    if ($params->allow_image_description)
    {
      foreach ($_POST as $field => $value)
      {
        if (preg_match('/description_(?P<digit>\d+)/', $field, $matches))
        {
          $id = $matches['digit'];

          $description = JRequest::getVar('description_'.$id, '', 'POST', 'string');

          if ($params->require_image_description &&
            !strlen($description))
          {
            $errors[$id][] = JText::_('Image description is required');
          }

          if (strlen($description) > $params->max_description_length)
          {
            $errors[$id][] = JText::_('Image description maximum length exceeeded');
          }
        }
      }
    }

    // Gender check
    if ($params->allow_gender)
    {
      foreach ($_POST as $field => $value)
      {
        if (preg_match('/gender_(?P<digit>\d+)/', $field, $matches))
        {
          $id = $matches['digit'];

          $gender = JRequest::getVar('gender_'.$id, -1, 'POST', 'integer');

          if (!in_array($gender, array(0, 1)))
          {
            $errors[$id][] = JText::_('You must select gender');
          }
        }
      }
    }

    // Tags check
    if ($params->allow_tags)
    {
      foreach ($_POST as $field => $value)
      {
        if (preg_match('/gender_(?P<digit>\d+)/', $field, $matches))
        {
          $id = $matches['digit'];
          $tags = JRequest::getVar('tags_'.$id, '', 'POST', 'string');

          if ($params->require_tags &&
              !strlen($tags))
          {
            $errors[$id][] = JText::_('Tags are required');
          }

          $no_tags = explode(',', $tags);
          if (count($no_tags) > $params->max_no_tags)
          {
            $errors[$id][] = JText::_('Maximum number of tags exceeded');
          }
        }
      }
    }

    return $errors;
  }

  function decodePath($path)
  {
    return base64_decode($path);
  }

  function encodePath($path)
  {
    return base64_encode($path);
  }

  function imageSrc($id, $extension, $folder, $type)
  {
    require_once(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_hotornot'.DS.'settings.php');
    $settings = new HNConfig();

    ($type == 'thumb') ? $type = '_thumb' : $type = '';

    $upload_folder = Helper::decodePath($settings->upload_folder);
    $upload_folder = str_replace(JPATH_ROOT, '', $upload_folder);
    $upload_folder = str_replace(DS, '/', $upload_folder);
    $upload_folder = ereg_replace('^/', '', $upload_folder);

    return JURI::root() . $upload_folder . '/' . $folder . '/' . $id . $type . '.' . $extension;
  }

  function saveCounter($counter)
  {
    $handle = fopen(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_hotornot'.DS.'fcounter.php', 'w');
    fwrite($handle, '<?php

defined(\'_JEXEC\') or die(\'Restricted access\');

class HNCounter
{
  var $current_count  = ' . $counter->current_count . ';
  var $current_folder = ' . $counter->current_folder . ';
}');
    fclose($handle);
  }

  function getCategorySelected()
  {
    $cookie = JRequest::getVar('category', -1, 'COOKIE', 'integer');
    return $cookie;
  }

  function getLoveFactoryIntegration()
  {
    $database =& JFactory::getDBO();

    $query = ' SELECT COUNT(id)'
           . ' FROM #__components'
           . ' WHERE link = "option=com_lovefactory"';
    $database->setQuery($query);

    return (boolean)$database->loadResult();
  }

  function getPhotoSource()
  {
    require_once(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_hotornot'.DS.'settings.php');
    $settings = new HNConfig();

    if (!Helper::getLoveFactoryIntegration())
    {
      return 0;
    }

    return $settings->photos_source;
  }
}