<?php

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');

class FrontendModelComment extends JModel
{
  var $id;
  var $name;
  var $comment;

  function __construct()
  {
    $database =& JFactory::getDBO();

    $this->id      = JRequest::getVar('id', 0, 'POST', 'integer');
    $this->comment = $database->getEscaped(JRequest::getVar('comment', '', 'POST', 'string'));
    $this->source  = $database->getEscaped(JRequest::getVar('source',  '', 'POST', 'string'));

    parent::__construct();
  }

  function getComment()
  {
    if ((empty($this->comment)) ||
        (!$this->id) ||
        (!Helper::canComment()))
    {
      return false;
    }

    $settings = new HNConfig();

    $database =& JFactory::getDBO();
    $user     =& JFactory::getUser();
    $comment  =& $this->getTable();
    $datenow  =& JFactory::getDate();

    $comment->image_id    = $this->id;
    $comment->source      = $this->source;
    $comment->user_id     = $user->id;
    $comment->receiver_id = $this->getReceiverId();
    $comment->comment     = $this->comment;
    $comment->date_added  = $datenow->toMySQL();
    $comment->approved    = !$settings->enable_comments_approval_system;

    $comment->store();

    $this->sendNewCommentNotification($comment);

    return true;
  }

  function sendNewCommentNotification($comment)
  {
    $settings = new HNConfig();

    // Check if new comment notifications are enabled
    if (!$settings->enable_new_comment_notification)
    {
      return false;
    }

    // Check if the user has a registered owner
    switch ($comment->source)
    {
      case 'hotornot':
        $query = ' SELECT i.user_id'
               . ' FROM #__hotornot_image i'
               . ' WHERE i.id = ' . $comment->image_id;
        $this->_db->setQuery($query);
        $user_id = $this->_db->loadResult();
      break;

      case 'lovefactory':
        if (!Helper::getLoveFactoryIntegration())
        {
          $user_id = 0;
        }
        else
        {
          $query = ' SELECT p.user_id'
                 . ' FROM #__lovefactory_photos p'
                 . ' WHERE p.id = ' . $comment->image_id;
          $this->_db->setQuery($query);
          $user_id = $this->_db->loadResult();
        }
      break;
    }

    $user =& JFactory::getUser($user_id);
    if ($user->guest)
    {
      return false;
    }

    // Send the notification
    $subject = base64_decode($settings->notification_new_comment_subject);
    $message = base64_decode($settings->notification_new_comment_message);

    $image_link         = JURI::root() . 'index.php?option=com_hotornot&task=show&id=' . $comment->image_id . '&source=' . $comment->source;
    $managecommentslink = JURI::root() . 'index.php?option=com_hotornot&task=managecomments';

    if ($settings->enable_html_emails)
    {
      $image_link         = '<a href="' . $image_link . '">' . $image_link . '</a>';
      $managecommentslink = '<a href="' . $managecommentslink . '">' . $managecommentslink . '</a>';
    }

    $search  = array('%%username%%',  '%%commenttext%%', '%%imagelink%%', '%%managecommentslink%%');
    $replace = array($user->username, $comment->comment, $image_link, $managecommentslink);

    $subject = str_ireplace($search, $replace, $subject);
    $message = str_ireplace($search, $replace, $message);

    if ($settings->enable_html_emails)
    {
      $subject = nl2br($subject);
      $message = nl2br($message);
    }

    // Send the mail
    $mail =& JFactory::getMailer();
    $mail->addRecipient($user->email);

    $mail->setSubject(JText::_($subject));
    $mail->setBody(JText::_($message));

    $mail->IsHTML($settings->enable_html_emails);

    $mail->send();
  }

  function getReceiverId()
  {
    switch ($this->source)
    {
      case 'lovefactory':
        $query = ' SELECT p.user_id'
               . ' FROM #__lovefactory_photos p'
               . ' WHERE p.id = ' . $this->id;
      break;

      case 'hotornot':
        $query = ' SELECT i.user_id'
               . ' FROM #__hotornot_image i'
               . ' WHERE i.id = ' . $this->id;
      break;
    }

    $this->_db->setQuery($query);
    return $this->_db->loadResult();
  }
}
