<?php

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');

class FrontendModelLatest extends JModel
{
  var $_data;
  var $_total;
  var $_pagination;
  var $_limit;
  var $_limitstart;

  function __construct()
  {
    parent::__construct();

    $settings = new HNConfig();

    global $mainframe, $option;
    $limit      =& JRequest::getVar('limit',      $settings->top_images_per_page, 'REQUEST', 'integer');
    $limitstart =& JRequest::getVar('limitstart', 0, 'REQUEST', 'integer');

    $limitstart = ($limit != 0 ? (floor($limitstart / $limit) * $limit) : 0);

    $this->_limit      = $limit;
    $this->_limitstart = $limitstart;
  }

  function getData()
  {
    if (empty($this->_data))
    {
      $query = $this->_buildQuery();
      $this->_data = $this->_getList($query, $this->_limitstart, $this->_limit);
    }

    return $this->_data;
  }

  function _buildQuery()
  {
    $settings = new HNConfig();
    $session  =& JFactory::getSession();

    $database =& JFactory::getDBO();

    $query1 = ' SELECT i.id, i.hits, i.rank, i.extension, i.folder, i.user_id, "hotornot" AS source, i.date_added'
            . ' FROM #__hotornot_image i'
            . ' WHERE i.approved = 1';

    $query2 = ' SELECT p.id, i.hits, i.rank, p.filename AS extension, "" AS folder, p.user_id, "lovefactory" AS source, "0000-00-00 00:00:00" AS date_added'
            . ' FROM #__lovefactory_photos p'
            . ' LEFT JOIN #__hotornot_image_lovefactory i ON p.id = i.image_id'
            . ' WHERE i.approved = 1';

    switch (Helper::getPhotoSource())
    {
      case 0:
        $query = $query1;
      break;

      case 1:
        $query = '(' . $query1 . ') UNION (' . $query2 . ')';
      break;

      case 2:
        $query = $query2;
      break;
    }

    $query .= ' ORDER BY date_added DESC';

    return $query;
  }

  function getTotal()
  {
    if (empty($this->_total))
    {
      $query = $this->_buildQuery();
      $this->_total = $this->_getListCount($query);
    }

    return $this->_total;
  }

  function getPagination()
  {
    if (empty($this->_pagination))
    {
      jimport('joomla.html.pagination');
      $this->_pagination = new JPagination($this->getTotal(), $this->_limitstart, $this->_limit);
    }

    return $this->_pagination;
  }
}