<?php

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');

class FrontendModelManageComments extends JModel
{
  var $_data;
  var $_total;
  var $_pagination;
  var $_limit;
  var $_limitstart;

  function __construct()
  {
    parent::__construct();

    $this->_limit      = JRequest::getVar('limit',      10, 'REQUEST', 'integer');
    $this->_limitstart = JRequest::getVar('limitstart', 0,  'REQUEST', 'integer');

    $this->_limitstart = ($this->_limit != 0 ? (floor($this->_limitstart / $this->_limit) * $this->_limit) : 0);
  }

  // Pagination
  function getData()
  {
    if (empty($this->_data))
    {
      $query = $this->_buildQuery();
      $this->_data = $this->_getList($query, $this->_limitstart, $this->_limit);
    }

    return $this->_data;
  }

  function _buildQuery()
  {
    $user =& JFactory::getUser();

    $query = ' SELECT c.*, IF (u.username IS NOT NULL, u.username, "' . JText::_('Anonymous') . '") AS username'
           . ' FROM #__hotornot_comment c'
           . ' LEFT JOIN #__users u ON u.id = c.user_id'
           . ' WHERE c.receiver_id = ' . $user->id
           . ' AND c.approved = 0';

    return $query;
  }

  function getTotal()
  {
    if (empty($this->_total))
    {
      $query = $this->_buildQuery();
      $this->_total = $this->_getListCount($query);
    }

    return $this->_total;
  }

  function getPagination()
  {
    if (empty($this->_pagination))
    {
      jimport('joomla.html.pagination');
      $this->_pagination = new JPagination($this->getTotal(), $this->_limitstart, $this->_limit);
    }

    return $this->_pagination;
  }

  // Tasks
  function approve()
  {
    if (!$this->validate())
    {
      return false;
    }

    $user    =& JFactory::getUser();
    $comment =& $this->getTable('comment');
    $id      =& JRequest::getVar('id', 0, 'GET', 'integer');

    $query = ' UPDATE #__hotornot_comment'
           . ' SET approved = 1'
           . ' WHERE id = ' . $id
           . ' AND receiver_id = ' . $user->id;
    $this->_db->setQuery($query);

    return $this->_db->query();
  }

  function delete()
  {
    if (!$this->validate())
    {
      return false;
    }

    $user    =& JFactory::getUser();
    $comment =& $this->getTable('comment');
    $id      =& JRequest::getVar('id', 0, 'GET', 'integer');

    $query = ' DELETE'
           . ' FROM #__hotornot_comment'
           . ' WHERE id = ' . $id
           . ' AND receiver_id = ' . $user->id;
    $this->_db->setQuery($query);

    return $this->_db->query();
  }

  function executeBulk()
  {
    if (!$this->validate())
    {
      return false;
    }

    $user   =& JFactory::getUser();
    $action =& JRequest::getVar('action', '',      'POST', 'string');
    $cids   =& JRequest::getVar('cid',    array(), 'POST', 'array');

    switch ($action)
    {
      case 'approve':
        $query = ' UPDATE #__hotornot_comment'
               . ' SET approved = 1';
      break;

      case 'delete':
        $query = ' DELETE'
               . ' FROM #__hotornot_comment';
      break;
    }

    $query .= ' WHERE id IN (' . implode(',', $cids) . ')'
           .  ' AND receiver_id = ' . $user->id;
    $this->_db->setQuery($query);

    return $this->_db->query();
  }

  function validate()
  {
    // Check if the user is logged in
    $user =& JFactory::getUser();
    if ($user->guest)
    {
      return false;
    }

    // Check if the commment approval system is enabled
    $settings = new HNConfig();

    if (!$settings->enable_comments_approval_system)
    {

      return false;
    }

    return true;
  }
}
