<?php

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');

class FrontendModelReport extends JModel
{
  var $id;
  var $type;
  var $send_mail;
  var $address;

  var $last_id;

  function __construct()
  {
    $settings = new HNConfig();
    $this->send_mail = $settings->send_email_report;
    $this->address   = $settings->email_address_report;

    $this->id   = JRequest::getVar('id', 0, 'POST', 'integer');
    $this->type = JRequest::getVar('type', 0, 'POST', 'integer');
    $this->source = JRequest::getVar('source', '', 'POST', 'string');

    if (!in_array($this->type, array(1, 2)))
    {
      return false;
    }

    parent::__construct();
  }

  function _buildQuery()
  {
    if ($this->type == 2)
    {
      $query = ' UPDATE #__hotornot_comment'
             . ' SET reports = reports + 1'
             . ' WHERE id = ' . $this->id;
    }
    else
    {
      $name    = JRequest::getVar('name',    '', 'POST', 'string');
      $email   = JRequest::getVar('email',   '', 'POST', 'string');
      $message = JRequest::getVar('message', '', 'POST', 'string');

      $query = ' INSERT INTO #__hotornot_report'
             . ' VALUES("", ' . $this->id . ', "' . $this->source . '", "' . $name . '", "' . $email . '", "' . $message . '", NOW())';
    }

    return $query;
  }

  function getReport()
  {
    $database =& JFactory::getDBO();

    $query = $this->_buildQuery();
    $database->setQuery($query);

    if ($database->query())
    {
      $this->last_id = ($this->type == 1) ? $database->insertid() : 0;

      if ($this->send_mail)
      {
        $this->sendMail();
      }
      return true;
    }

    return false;
  }

  function sendMail()
  {
    global $mainframe;

    JUtility::sendMail(
      $mainframe->getCfg('mailfrom'),
      $mainframe->getCfg('sitename'),
      $this->address,
      $mainframe->getCfg('sitename') . ' Report',
      $this->getMailTemplate(),
      1);
  }

  function getMailTemplate()
  {
    if ($this->type == 2)
    {
      $query = ' SELECT id, image_id, name, comment, date_added, reports'
             . ' FROM #__hotornot_comment'
             . ' WHERE id = ' . $this->id;
    }
    else
    {
      $query = ' SELECT i.id, i.extension, i.folder, r.name, r.email, r.message, r.date_added'
             . ' FROM #__hotornot_report r'
             . ' LEFT JOIN #__hotornot_image i ON i.id = r.image_id'
             . ' WHERE r.id = ' . $this->last_id;
    }

    $database =& JFactory::getDBO();
    $database->setQuery($query);
    $result = $database->loadAssoc();

    if ($this->type == 2)
    {
      $template = '
<table>
  <tr>
    <td colspan="2">The following comment has been reported:</td>
  </tr>
  <tr>
    <td><b>Author:</b></td>
    <td>' . $result['name'] . '</td>
  </tr>
  <tr>
    <td><b>Date added:</b></td>
    <td>' . $result['date_added'] . '</td>
  </tr>
  <tr>
    <td valign="top"><b>Comment:</b></td>
    <td>' . nl2br($result['comment']) . '</td>
  </tr>
  <tr>
    <td><b>Number of reports:</b></td>
    <td>' . $result['reports'] . '</td>
  </tr>
</table>';
    }
    else
    {
      require_once(JPATH_COMPONENT.DS.'helper.php');
      $template = '
<table>
  <tr>
    <td colspan="2">The following image has been reported:</td>
  </tr>
  <tr>
    <td valign="top"><img src="' . Helper::imageSrc($result['id'], $result['extension'], $result['folder'], 'thumb') . '" /></td>
    <td valign="top">
      <table>
        <tr>
          <td><b>Name:</b></td>
          <td>' . $result['name'] . '</td>
        </tr>
        <tr>
          <td><b>Email:</b></td>
          <td>' . $result['email'] . '</td>
        </tr>
        <tr>
          <td valign="top"><b>Message:</b></td>
          <td>' . nl2br($result['message']) . '</td>
        </tr>
      </table>
    </td>
</table>';
    }

    return $template;
  }
}