<?php

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');

class FrontendModelShow extends JModel
{
  var $id;
  var $source;

  function __construct()
  {
    $this->id = JRequest::getVar('id', 0, 'GET', 'integer');

    parent::__construct();
  }

  function _buildQuery($new_source = null)
  {
    switch ($this->getPhotoSource())
    {
      // No integration
      case 0:
        $query = $this->getQueryForHotornot();
        $this->source = 'hotornot';
      break;

      // And Love Factory
      case 1:
        // Show a particular photo
        if ($this->id)
        {
          $this->source = JRequest::getVar('source', '', 'REQUEST', 'string');
          if ($this->source == 'hotornot')
          {
            $query = $this->getQueryForHotornot();
          }
          else
          {
            $query = $this->getQueryForLovefactory();
          }

          return $query;
        }

        // Retry
        if ($new_source)
        {
          if ($new_source == 'hotornot')
          {
            $this->source = 'hotornot';
            $query = $this->getQueryForHotornot();
          }
          else
          {
            $this->source = 'lovefactory';
            $query = $this->getQueryForLovefactory();
          }

          return $query;
        }

        // Random
        if (rand(0, 1))
        {
          $this->source = 'hotornot';
          $query = $this->getQueryForHotornot();
        }
        else
        {
          $this->source = 'lovefactory';
          $query = $this->getQueryForLovefactory();
        }
      break;

      // Only Love Factory
      case 2:
        $query = $this->getQueryForLovefactory();
        $this->source = 'lovefactory';
      break;
    }

    #var_dump($query);

    return $query;
  }

  function getQueryForLovefactory()
  {
    $category = JRequest::getVar('category', -1, 'COOKIE', 'integer');

    $query = ' SELECT p.id, p.user_id, i.hits, i.rank, p.filename AS extension, "lovefactory" AS source, "" AS folder, "" AS description,'
           . '   0 AS category_id, "" AS category_name, u.username AS username'
           . ' FROM #__lovefactory_photos p'
           . ' LEFT JOIN #__hotornot_image_lovefactory i ON p.id = i.image_id'
           . ' LEFT JOIN #__users u ON u.id = p.user_id'
           . ' WHERE p.id ' . (($this->id) ? ' = ' . $this->id : ' NOT IN (' . $this->getLovefactoryVotedImages() . ')')
           . (($this->id || $category == 0) ? '' : $this->getCategoryQueryCondition())
           . ' AND i.approved = 1'
           . (($this->id) ? '' : ' ORDER BY RAND()');

    $query .= ' LIMIT 0,1';

    return $query;
  }

  function getQueryForHotornot()
  {
    $query = ' SELECT i.id, i.user_id, i.hits, i.rank, i.extension, "hotornot" AS source, i.folder, i.description, c.icon AS category_icon,'
           . '   i.category_id, c.title AS category_name, IF(u.username IS NOT NULL, u.username, "' . JText::_('Anonymous') . '") AS username'
           . ' FROM #__hotornot_image i'
           . ' LEFT JOIN #__users u ON u.id = i.user_id'
           . ' LEFT JOIN #__hotornot_categories c ON c.id = i.category_id'
           . ' WHERE i.id';

    $query .= ($this->id) ? ' = ' . mysql_escape_string($this->id) : ' NOT IN (' . $this->getVotedImages() .')';
    $query .= ($this->id) ? '' : $this->getCategoryQueryCondition();
    $query .= ' AND i.approved = 1';
    $query .= ($this->id) ? '' : ' ORDER BY RAND()';

    $query .= ' LIMIT 0,1';
    return $query;
  }

  function getImage()
  {
    $database =& JFactory::getDBO();

    $query = $this->_buildQuery();
    $database->setQuery($query);
    $image = $database->loadAssoc();

    if ($image == null && $this->getPhotoSource() == 1)
    {
      $new_source = ($this->source == 'hotornot') ? 'lovefactory' : 'hotornot';

      $query = $this->_buildQuery($new_source);
      $database->setQuery($query);
      $image = $database->loadAssoc();
    }

    $this->id = $image['id'];

    // Register session for Random Image Module
    $session =& JFactory::getSession();
    $session->set('hotornot_last_viewed', $this->id);
    $session->set('hotornot_last_viewed_source', $this->source);

    return $image;
  }


  function getVotedImages()
  {
    return $this->getVotedImagesFromDatabase();
  }

  function getVotedImagesFromDatabase()
  {
    $settings =  new HNConfig();

    if ($settings->voting_interval == 0)
    {
      return 0;
    }

    $database =& JFactory::getDBO();
    $user     =& JFactory::getUser();

    $query = ' SELECT image_id'
           . ' FROM #__hotornot_vote'
           . ' WHERE ' . (($user->guest) ? ' ip = "' . $_SERVER['REMOTE_ADDR'] . '"' : ' user_id = ' . $user->id)
           . ' AND (' . time() . ' - UNIX_TIMESTAMP(voted_at)) <= ' . $settings->voting_interval * 60 * 60 * 24
           . ' AND source = "hotornot"';
    $database->setQuery($query);
    $vote = $database->loadResultArray();

    return ($vote) ? implode(', ', $vote) : 0;
  }

  function getLovefactoryVotedImages()
  {
    $settings =  new HNConfig();

    if ($settings->voting_interval == 0)
    {
      return 0;
    }

    $database =& JFactory::getDBO();
    $user     =& JFactory::getUser();

    $query = ' SELECT image_id'
           . ' FROM #__hotornot_vote'
           . ' WHERE ' . (($user->guest) ? ' ip = "' . $_SERVER['REMOTE_ADDR'] . '"' : ' user_id = ' . $user->id)
           . ' AND (' . time() . ' - UNIX_TIMESTAMP(voted_at)) <= ' . $settings->voting_interval * 60 * 60 * 24
           . ' AND source = "lovefactory"';
    $database->setQuery($query);
    $vote = $database->loadResultArray();

    return ($vote) ? implode(', ', $vote) : 0;
  }

  function getCategoryQueryCondition()
  {
    $category = JRequest::getVar('category', -1, 'COOKIE', 'integer');

    if ($category != -1)
    {
      return ' AND i.category_id = ' . $category;
    }
  }

  function getAlreadyVoted()
  {
    if ($this->source == 'hotornot')
    {
      return $this->getAlreadyVotedFromDatabase();
    }
    else
    {
      return $this->getLovefactoryAlreadyVoted();
    }
  }

  function getAlreadyVotedFromDatabase()
  {
    $settings =  new HNConfig();

    if ($settings->voting_interval == 0)
    {
      return false;
    }

    $database =& JFactory::getDBO();
    $user     =& JFactory::getUser();

    $query = ' SELECT id'
           . ' FROM #__hotornot_vote'
           . ' WHERE ' . (($user->guest) ? ' ip = "' . $_SERVER['REMOTE_ADDR'] . '"' : ' user_id = ' . $user->id)
           . ' AND (' . time() . ' - UNIX_TIMESTAMP(voted_at)) <= ' . $settings->voting_interval * 60 * 60 * 24
           . ' AND image_id = ' . $this->id
           . ' AND source = "hotornot"';
    $database->setQuery($query);
    $vote = $database->loadResult();

    return $vote;
  }

  function getLovefactoryAlreadyVoted()
  {
    $settings =  new HNConfig();

    if ($settings->voting_interval == 0)
    {
      return false;
    }

    $database =& JFactory::getDBO();
    $user     =& JFactory::getUser();

    $query = ' SELECT id'
           . ' FROM #__hotornot_vote'
           . ' WHERE ' . (($user->guest) ? ' ip = "' . $_SERVER['REMOTE_ADDR'] . '"' : ' user_id = ' . $user->id)
           . ' AND (' . time() . ' - UNIX_TIMESTAMP(voted_at)) <= ' . $settings->voting_interval * 60 * 60 * 24
           . ' AND image_id = ' . $this->id
           . ' AND source = "lovefactory"';
    $database->setQuery($query);
    $vote = $database->loadResult();

    return $vote;
  }

  function getTags()
  {
    $database =& JFactory::getDBO();

    $query = ' SELECT name'
           . ' FROM #__hotornot_tag'
           . ' WHERE image_id = ' . $this->id;
    $database->setQuery($query);
    return $database->loadResultArray();
  }

  function getLoveFactoryIntegration()
  {
    $query = ' SELECT COUNT(id)'
           . ' FROM #__components'
           . ' WHERE link = "option=com_lovefactory"';
    $this->_db->setQuery($query);

    return (boolean)$this->_db->loadResult();
  }

  function getPhotoSource()
  {
    $settings = new HNConfig();

    if (!$this->getLoveFactoryIntegration())
    {
      return 0;
    }

    return $settings->photos_source;
  }

  function getCategories()
  {
    $query = ' SELECT c.id, c.title, c.icon'
           . ' FROM #__hotornot_categories c'
           . ' ORDER BY c.ordering ASC';
    $this->_db->setQuery($query);

    return $this->_db->loadObjectList();
  }

  function getNumCategoryPhotos($category_id)
  {
    $query1 = ' SELECT COUNT(i.id)'
            . ' FROM #__hotornot_image i'
            . ' WHERE i.category_id = ' . $category_id
            . ' AND i.approved = 1';

    $query2 = ' SELECT COUNT(p.id)'
            . ' FROM #__lovefactory_photos p'
            . ' LEFT JOIN #__hotornot_image_lovefactory i ON i.image_id = p.id'
            . ' WHERE i.category_id = ' . $category_id
            . ' AND i.approved = 1';

    switch ($this->getPhotoSource())
    {
      case 0:
        $this->_db->setQuery($query1);
        $total = $this->_db->loadResult();
      break;

      case 1:
        $this->_db->setQuery($query1);
        $total = $this->_db->loadResult();

        $this->_db->setQuery($query2);
        $total += $this->_db->loadResult();
      break;

      case 2:
        $this->_db->setQuery($query2);
        $total = $this->_db->loadResult();
      break;
    }

    return $total;
  }

  function getLastVoted()
  {
    $user =& JFactory::getUser();

    $query = ' SELECT voted_at'
           . ' FROM #__hotornot_vote'
           . ' WHERE ' . (($user->guest) ? ' ip = "' . $_SERVER['REMOTE_ADDR'] . '"' : ' user_id = ' . $user->id)
           . ' AND image_id = ' . $this->id
           . ' AND source = "hotornot"';
    $this->_db->setQuery($query);
    $date = $this->_db->loadResult();

    $query = ' SELECT UNIX_TIMESTAMP("' . $date . '")';
    $this->_db->setQuery($query);

    if (!$date)
    {
      return false;
    }

    $test = number_format((time() - strtotime($date)) / 60 / 60, 2);

    echo '<pre>';
    var_dump($test);
    echo '</pre>';
  }
}