<?php

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');

class FrontendModelVote extends JModel
{
  var $vote;
  var $id;

  function __construct()
  {
    $this->id     = JRequest::getVar('id',     0,  'POST', 'integer');
    $this->vote   = JRequest::getVar('vote',   0,  'POST', 'integer');
    $this->source = JRequest::getVar('source', '', 'POST', 'string');

    $settings = new HNConfig();
    if ($this->vote > $settings->scale_top)
    {
      $this->vote = $settings->scale_top;
    }

    parent::__construct();
  }

  function registerVoter()
  {
    return $this->registerVoterByDatabase();
  }

  function registerVoterByDatabase()
  {
    if (!in_array($this->source, array('hotornot', 'lovefactory')))
    {
      return false;
    }

    $settings =  new HNConfig();
    $database =& JFactory::getDBO();
    $user     =& JFactory::getUser();
    $date     =  date('Y-m-d H:i:s', time());

    $query = ' SELECT id, voted_at'
           . ' FROM #__hotornot_vote'
           . ' WHERE ' . (($user->guest) ? ' ip = "' . $_SERVER['REMOTE_ADDR'] . '"' : ' user_id = ' . $user->id)
           . ' AND image_id = ' . $this->id
           . ' AND source = "' . $this->source . '"';
    $database->setQuery($query);
    $vote = $database->loadAssoc();

    // First vote
    if ($vote == null)
    {
      $query = ' INSERT INTO #__hotornot_vote'
             . ' VALUES("", "' . (($user->id) ? $user->id : '') . '", "' . (($user->id) ? '' : $_SERVER['REMOTE_ADDR']) . '", ' . $this->id . ', "' . $this->source . '", "' . $date . '")';
      $database->setQuery($query);
      return $database->query();
    }

    $voted_at = strtotime($vote['voted_at']);
    $now      = time();

    $difference = $now - $voted_at;
    $difference = $difference / 60 / 60 / 24;

    if ($difference > $settings->voting_interval)
    {
      $query = ' UPDATE #__hotornot_vote'
             . ' SET voted_at = "' . $date . '"'
             . ' WHERE ' . (($user->guest) ? ' ip = "' . $_SERVER['REMOTE_ADDR'] . '"' : ' user_id = ' . $user->id)
             . ' AND image_id = ' . $this->id
             . ' AND source = "' . $this->source . '"';
      $database->setQuery($query);
      return $database->query();
    }

    return false;
  }

  function registerVote()
  {
    $database =& JFactory::getDBO();
    $params   =& JComponentHelper::getParams('com_hotornot');
    $scale    = $params->get('voting_scale');

    if ($this->source == 'hotornot')
    {
      $query = ' SELECT i.hits, i.rank'
             . ' FROM #__hotornot_image i'
             . ' WHERE i.id = ' . $this->id;
      $database->setQuery($query);
      $image = $database->loadAssoc();

      $rank = ($image['rank'] * $image['hits'] + $this->vote) / ($image['hits'] + 1);

      $query = ' UPDATE #__hotornot_image'
             . ' SET hits = ' . ($image['hits'] + 1) . ', rank = ' .$rank
             . ' WHERE id = ' . $this->id;
      $database->setQuery($query);

      if (!$database->query())
      {
        return false;
      }
    }
    else
    {
      $query = ' SELECT i.hits, i.rank'
             . ' FROM #__hotornot_image_lovefactory i'
             . ' WHERE i.image_id = ' . $this->id;
      $database->setQuery($query);
      $image = $database->loadAssoc();

      if ($image == null)
      {
        $query = ' INSERT INTO #__hotornot_image_lovefactory VALUES("", ' . $this->id . ', 0, 0, "")';
        $database->setQuery($query);
        $database->query();
      }

      $rank = ($image['rank'] * $image['hits'] + $this->vote) / ($image['hits'] + 1);

      $query = ' UPDATE #__hotornot_image_lovefactory'
             . ' SET hits = ' . ($image['hits'] + 1) . ', rank = ' .$rank
             . ' WHERE image_id = ' . $this->id;
      $database->setQuery($query);

      if (!$database->query())
      {
        return false;
      }
    }

    // Register session for Last Voted Module
    $session =& JFactory::getSession();
    $session->set('hotornot_last_voted',        $this->id);
    $session->set('hotornot_last_voted_source', $this->source);

    return true;
  }
}
